#ifndef _HAS_AOLMAIL_H_
#define _HAS_AOLMAIL_H_

#include <vector>

#include <aolmodule.h>

class AOLmail : public AOLModule {
  public:
    AOLmail(AOLConn * aolConn);
    virtual ~AOLmail();

    virtual void ReceiveP3(string code, P3 * p3);

    class Attachment {
      public:
        Attachment();
        ~Attachment();

        string filename;
        int type;
        int size;
    };

    class Message {
      public:
        Message();
        ~Message();

        int id;

        string date;
        string from;
        string subject;
        vector<string> to, cc, bcc;

        int length;
        byte * body;

        vector<Attachment *> attachments;
    };

    enum Mailboxes {
      NewMbox = 0,
      OldMbox,
      ReadMbox
    };

  private:

};

#endif /* _HAS_AOLMAIL_H_ */
