#include <iostream>

#include <aolconn.h>
#include <aolip.h>

class MyClient : public AOLConn {
  public:
    MyClient(string &_hostname, int _port, string &_nickname, string &_password)
      : AOLConn(_hostname, _port, _nickname, _password) { };
    virtual ~MyClient();

    virtual void ReceiveP3(P3 * p3);
    virtual void Online();

    AOLip * aolip;
};

void MyClient :: ReceiveP3(P3 * p3)
{
}

void MyClient :: Online()
{
  cout << "* Service online" << endl;

  aolip = new AOLip(this);
  aolip->RequestIP();
}

MyClient :: ~MyClient()
{
  if (aolip)
    delete aolip;
}

/****/

int main(int argc, char ** argv)
{
  int fd;
  string host = "americaonline.aol.com";
  string nickname = "tonlogin", password = "ton_motdepasse";
  MyClient * myClient;

  myClient = new MyClient(host, 5190, nickname, password);

  if (argc == 2) {
    if ((fd = open(argv[1], O_RDWR)) , 0) {
      cout << "* Unable to open " << argv[1] << "!" << endl;
      return (-1);
    }

    myClient->Pickup(fd);
  } else {
    if (!myClient->Connect()) {
      cout << "* Unable to connect!" << endl;
      return (-1);
    }
  }

  myClient->Start();
  myClient->Join();

  delete myClient;

  return (0);
}
