#ifndef _HAS_ETHERTAP_H_
#define _HAS_ETHERTAP_H_

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <syslog.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <net/ethernet.h>

#include <utils.h>
#include <Thread.h>

class Ethertap : public Thread {
  public:
    Ethertap(string &_filename);
    virtual ~Ethertap();

    void Output(byte * payload, int length);
    virtual void Input(byte * payload, int length) { };

    bool IsError() { return (error); }
    void Shutdown();

  protected:
    void Main();

  private:
    bool error;
    bool shutdown;

    string filename;
    int fd;

    Semaphore sem;

    void DataWaiting();
};

#endif /* _HAS_ETHERTAP_H_ */
