#ifndef _HAS_P3_H_
#define _HAS_P3_H_

#include <Memory.h>
#include <Byte.h>
#include <TCPThread.h>
#include <Buffer.h>
#include <CRC.h>

class AOLConn;

class P3 {
  public:
    P3();
    P3(int _type, string payload = "");
    P3(Buffer * buffer);
    virtual ~P3();

    void Payload(Buffer * buffer);
    void Write(AOLConn * aolConn);

    bool StartsWith(string s);

    enum Types {
      DataT      = 32,
      Unknown1T  = 33,
      Unknown2T  = 34,
      InitT      = 35,
      AckT       = 36,
      NakT       = 37,
      HeartbeatT = 38,
      Unknown3T  = 40,
      Unknown4T  = 41
    };

    unsigned short crc;
    unsigned short length;
    byte sequence, ack;
    byte type;
    Buffer * buffer;
    string stringbuffer;
};

#endif /* _HAS_P3_H_ */
