#ifndef _HAS_BUFFER_H_
#define _HAS_BUFFER_H_

#include <iostream>
#include <string>

#include <utils.h>
#include <Byte.h>
#include <Thread.h>

class Buffer
{
  public:
    Buffer(byte *, int, bool = true);
    Buffer(int, bool = true);
    Buffer(string, bool = true);
    Buffer(Buffer *);
    ~Buffer();

    void Append(byte *, int);
    void Block(bool);

    void Reset();

    int Length();
    int Available();
    int Total();
    byte * Data();
    byte * DataP();

    UInt8 GetUInt8();
    int PutUInt8(UInt8);

    Int8 GetInt8();
    int PutInt8(Int8);

    UInt16 GetUInt16();
    int PutUInt16(UInt16);

    Int16 GetInt16();
    int PutInt16(Int16);

    UInt32 GetUInt32();
    int PutUInt32(UInt32);

    Int32 GetInt32();
    int PutInt32(Int32);

    byte GetByte();
    int PutByte(byte);

    byte * GetRaw(int);
    int PutRaw(byte *, int);
    int PutRaw(string &);

    string GetString(int);
    int PutString(string);

    string GetStringLen();
    int PutStringLen(string);

    int PutBuffer(Buffer *);
    Buffer * GetBuffer(int);

    int Skip(int);
    int Rewind(int);

  private:
    byte * buffer;
    byte * p;
    int pos, end;
    bool swap;

    Semaphore sem;
    bool block;
};

#endif /* _HAS_BUFFER_H_ */
