#ifndef _HAS_MEMORY_H_
#define _HAS_MEMORY_H_

#include <string.h>
#include <stdlib.h>
#include <errno.h>

#include <utils.h>

void * _Alloc(long int size, char * file, int line);
void * _AllocN(long int count, long int size, char * file, int line);
void * _Resize(void * p, long int size, char * file, int line);
void   _Free(void * p, char * file, int line);
void * _Copy(void * p, long int size, char * file, int line);

#define Alloc(size)     _Alloc(size, __FILE__, __LINE__)
#define AllocN(count, size) _AllocN(count, size, __FILE__, __LINE__)
#define Resize(ptr, size)   _Resize(ptr, size, __FILE__, __LINE__)
#define Free(ptr)       _Free(ptr, __FILE__, __LINE__)
#define Copy(src, size) _Copy(src, size, __FILE__, __LINE__)

void fmt_buf(byte * buf, int len);

#endif /* _HAS_MEMORY_H_ */
