#ifndef _HAS_TCPTHREAD_H_
#define _HAS_TCPTHREAD_H_

#include <string>

#include <Memory.h>
#include <Thread.h>
#include <Buffer.h>

class TCPThread : public Thread
{
  public:
    TCPThread(string = "untitled");
    virtual ~TCPThread();

    string Name();

    bool Connect(string);
    bool Connect(string, int);
    bool Listen(string);
    bool Listen();
    bool Pickup(int);
    int Accept();
    void Close();
    void Shutdown();

    int Read(void *, int);
	Buffer * Read(int);
    int Send(void *, int);
	int Send(Buffer *);

    virtual void DataWaiting();
    virtual void ClientWaiting();
    virtual void Connected();
    virtual void Disconnected();

  protected:
    void Main();

  private:
    string name;

    bool server;
    bool shutdown;
    bool connected;
    int fd;

    Semaphore sem;

    int writen(int fd, byte * ptr, int n);
    int readn(int fd, byte * ptr, int n);
};

#endif /* _HAS_TCPTHREAD_H_ */
