#include <iostream>

#include <Thread.h>

Semaphore :: Semaphore(string name_ = "untitled")
{
  name = name_;

  pthread_mutex_init(&semaphore, NULL);
}

Semaphore :: ~Semaphore()
{
  pthread_mutex_destroy(&semaphore);
}

int Semaphore :: Lock()
{
  return (pthread_mutex_lock(&semaphore));
}

int Semaphore :: Unlock()
{
  return (pthread_mutex_unlock(&semaphore));
}

/****/

Thread :: Thread(string name_ = "untitled")
{
  name    = name_;

  done    = false;
  started = false;
}

Thread :: ~Thread()
{
  if (!done && started)
    pthread_cancel(pthread_id);
}

bool Thread :: Start()
{
  if (started)
    return (false);

  if (pthread_create(&pthread_id, NULL, (void *(*)(void *)) start, this) < 0)
    return (false);
  else
    return (true);
}

bool Thread :: Join()
{
  if (pthread_join(pthread_id, NULL))
    return (false);
  else
    return (true);
}

void Thread :: Kill()
{
  if (started && !done)
    pthread_cancel(pthread_id);
}

void Thread :: PreMain()
{
}

void Thread :: PostMain()
{
}

void Thread :: Killed()
{
}

void Thread :: start(void * self_)
{
  Thread * self = (Thread *) self_;

  self->done    = false;
  self->started = true;

  self->PreMain();
  self->Main();
  self->PostMain();

  self->done    = true;

  pthread_exit(NULL);
}
