#ifndef _HAS_THREAD_H_
#define _HAS_THREAD_H_

#include <string>

#include <pthread.h>

class Semaphore
{
  public:
    Semaphore(string = "untitled");
    virtual ~Semaphore();

    int Lock();
    int Unlock();

  private:
    string name;
    pthread_mutex_t semaphore;
};

class Thread
{
  public:
    Thread(string = "untitled");
    virtual ~Thread();

    bool Start();
    bool Join();
    void Kill();

    bool HasStarted() const
    {
      return (started);
    }

    bool IsDone() const
    {
      return (done);
    }

  protected:
    virtual void PreMain();
    virtual void Main() = 0;
    virtual void PostMain();
    virtual void Killed();

  private:
    string name;
    pthread_t pthread_id;
    volatile bool done;
    volatile bool started;

    static void start(void *);
};

#endif /* _HAS_THREAD_H_ */
